## s390-tools 2.12.0

=== Makefile ===
ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)

# Include common definitions
include common.mak

LIB_DIRS = libvtoc libutil libzds libdasd libvmdump libccw libvmcp
TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl
SUB_DIRS = $(LIB_DIRS) $(TOOL_DIRS)

all: $(TOOL_DIRS)
clean: $(TOOL_DIRS)
install: $(TOOL_DIRS)

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

#
# We have to build the libraries before the tools are built. Otherwise
# the tools would trigger parallel "make -C" builds for libraries in
# case of "make -j".
#
# MAKECMDGOALS contains the list of goals, e.g. "clean all". We use
# "foreach" to generate a ";" separated list of "make -C <target>".
# For example the the expansion for "make clean all" is:
#
# $(MAKE) -C $@ [..] clean ;  $(MAKE) -C $@ [...] all ;
#
# This ensures that the commandline targets are serialized and also "make -j"
# works as expected, e.g. "make clean all -j 20".
#

$(TOOL_DIRS): $(LIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(TOOL_DIRS)

$(LIB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(LIB_DIRS)

=== cpacfstats/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -DVERSION=$(VERSION)


ifeq (${HAVE_PFM},0)

all:
	$(SKIP) HAVE_PFM=0

install:
	$(SKIP) HAVE_PFM=0

else

check_dep:
	$(call check_dep, \
			"cpacfstats", \
			"perfmon/pfmlib.h", \
			"libpfm-devel or libpfm4-dev", \
			"HAVE_PFM=0")

all:		check_dep cpacfstats cpacfstatsd

cpacfstatsd:	cpacfstatsd.o stats_sock.o perf_crypto.o
		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -lpfm -o $@

cpacfstats:	cpacfstats.o stats_sock.o
		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

install: 	all
		$(INSTALL) -m 755 cpacfstatsd   $(DESTDIR)$(USRSBINDIR)
		$(INSTALL) -m 755 cpacfstats    $(DESTDIR)$(USRBINDIR)
		$(INSTALL) -m 644 cpacfstatsd.8 $(DESTDIR)$(MANDIR)/man8
		$(INSTALL) -m 644 cpacfstats.1  $(DESTDIR)$(MANDIR)/man1

endif
clean:
		rm -f *.o *~ cpacfstatsd cpacfstats

.PHONY: all clean install check_dep

=== cpumf/Makefile ===
#!/usr/bin/make -f

include ../common.mak


CPUMF_DATADIR = $(TOOLS_DATADIR)/cpumf
DATA_FILES = cpum-cf-hw-counter.map \
	     cpum-cf-cfvn-1.ctr cpum-cf-cfvn-3.ctr \
	     cpum-cf-csvn-12345.ctr cpum-cf-csvn-6.ctr \
             cpum-cf-extended-z10.ctr cpum-cf-extended-z196.ctr \
	     cpum-cf-extended-zEC12.ctr cpum-sf-modes.ctr \
	     cpum-cf-extended-z13.ctr cpum-cf-extended-z14.ctr
LIB_FILES = bin/cpumf_helper
USRBIN_SCRIPTS = bin/lscpumf
USRSBIN_SCRIPTS = bin/chcpumf
MAN_FILES = lscpumf.1 chcpumf.8

all:

scripts: $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS) $(LIB_FILES)
	chmod +x $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS) $(LIB_FILES)

check:

install: scripts install-man
	for prg in $(USRBIN_SCRIPTS); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(DESTDIR)$(USRBINDIR) ; \
	done
	for prg in $(USRSBIN_SCRIPTS); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(DESTDIR)$(USRSBINDIR) ; \
	done
	test -d $(DESTDIR)$(CPUMF_DATADIR) || mkdir -p $(DESTDIR)$(CPUMF_DATADIR)
	for lib in $(LIB_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$lib $(DESTDIR)$(TOOLS_LIBDIR) ; \
	done
	for data in $(DATA_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 data/$$data $(DESTDIR)$(CPUMF_DATADIR) ; \
	done

install-man:
	for man in $(MAN_FILES); do \
	  msection=`echo $$man |sed 's/.*\.\([1-9]\)$$/man\1/'` ; \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 -D man/$$man $(DESTDIR)$(MANDIR)/$$msection/$$man ; \
	done

man2pdf:
	for man in $(MAN_FILES); do \
	  man -t man/$$man |ps2pdf -sPAPERSIZE=a4 - man/$${man}.pdf ; \
	done
man2text:
	for man in $(MAN_FILES); do \
	  MANWIDTH=80 LANG=C man man/$$man |col -b |expand > man/$${man}.txt ; \
	done

clean:
	rm -f $(LIB_FILES) $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS)

%: %.in
	real_libdir=$(TOOLS_LIBDIR); \
	real_cpumfdatadir=$(CPUMF_DATADIR); \
	$(SED) -e "s#@lib_path@#$$real_libdir#g" \
	       -e "s#@cpumfdata_path@#$$real_cpumfdatadir#g" \
	       -e 's#@S390_TOOLS_RELEASE@#$(S390_TOOLS_RELEASE)#g' \
	< $< > $@

.PHONY: all scripts install install-man man2pdf man2text clean

=== dasdfmt/Makefile ===
include ../common.mak

all: dasdfmt

libs =	$(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libvtoc/libvtoc.a \
	$(rootdir)/libutil/libutil.a

dasdfmt: dasdfmt.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdfmt $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdfmt.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdfmt core

.PHONY: all install clean

=== dasdview/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -DSYSFS

all: dasdview

libs =	$(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libzds/libzds.a \
	$(rootdir)/libvtoc/libvtoc.a \
	$(rootdir)/libutil/libutil.a

dasdview: dasdview.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdview $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdview.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdview core

.PHONY: all install clean

=== fdasd/Makefile ===
include ../common.mak

libs =	$(rootdir)/libvtoc/libvtoc.a \
	$(rootdir)/libzds/libzds.a \
	$(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libutil/libutil.a

all: fdasd

fdasd: fdasd.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 fdasd $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 fdasd.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ fdasd core

.PHONY: all install clean

=== ip_watcher/Makefile ===
include ../common.mak

all: xcec-bridge

libs =	$(rootdir)/libutil/libutil.a

xcec-bridge: xcec-bridge.o $(libs)

clean:
	rm -f *.o core xcec-bridge

install: ip_watcher.pl xcec-bridge start_hsnc.sh
	$(SED) -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
	< start_hsnc.sh >$(DESTDIR)$(USRSBINDIR)/start_hsnc.sh; \
	chown $(OWNER).$(GROUP) $(DESTDIR)$(USRSBINDIR)/start_hsnc.sh; \
	chmod 755 $(DESTDIR)$(USRSBINDIR)/start_hsnc.sh; \
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ip_watcher.pl \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 xcec-bridge \
		$(DESTDIR)$(USRSBINDIR)

.PHONY: all install clean

=== ipl_tools/Makefile ===
include ../common.mak

libs = $(rootdir)/libutil/libutil.a

all: chreipl lsreipl chshut lsshut

libs =	$(rootdir)/libutil/libutil.a

objects = main.o ccw.o fcp.o system.o shutdown.o \
	  cmd_lsshut.o cmd_chshut.o cmd_lsreipl.o cmd_chreipl.o proc.o

chreipl: $(objects) $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

lsreipl:
	ln -sf chreipl lsreipl

chshut:
	ln -sf chreipl chshut

lsshut:
	ln -sf chreipl lsshut

clean:
	rm -f *.o lsreipl chreipl chshut lsshut

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 chreipl \
		$(DESTDIR)$(USRSBINDIR)
	ln -f -s chreipl $(DESTDIR)$(USRSBINDIR)/lsreipl
	ln -f -s chreipl $(DESTDIR)$(USRSBINDIR)/chshut
	ln -f -s chreipl $(DESTDIR)$(USRSBINDIR)/lsshut
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/chreipl.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/lsreipl.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/lsshut.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/chshut.8 \
		$(DESTDIR)$(MANDIR)/man8

.PHONY: all install clean

=== libutil/Makefile ===
include ../common.mak

lib = libutil.a

examples =	util_base_example \
		util_panic_example \
		util_path_example \
		util_scandir_example \
		util_file_example \
		util_libc_example \
		util_opt_example \
		util_opt_command_example \
		util_prg_example \
		util_rec_example

all: $(lib)
examples: $(lib) $(examples)

objects =	util_base.o \
		util_path.o \
		util_scandir.o \
		util_file.o \
		util_libc.o \
		util_list.o \
		util_opt.o \
		util_panic.o \
		util_part.o \
		util_prg.o \
		util_proc.o \
		util_rec.o \
		util_sys.o

util_base_example: util_base_example.o $(lib)
util_panic_example: util_panic_example.o $(lib)
util_path_example: util_path_example.o $(lib)
util_scandir_example: util_scandir_example.o $(lib)
util_file_example: util_file_example.o $(lib)
util_libc_example: util_libc_example.o $(lib)
util_opt_example: util_opt_example.o $(lib)
util_opt_command_example: util_opt_command_example.o $(lib)
util_panic_example: util_panic_example.o $(lib)
util_prg_example: util_prg_example.o $(lib)
util_rec_example: util_rec_example.o $(lib)

$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib) $(examples)

=== libzds/Makefile ===
include ../common.mak

ALL_CFLAGS += -D_FILE_OFFSET_BITS=64

lib = libzds.a

all: $(lib)

objects = libzds.o

$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib)

.PHONY: all install clean

=== netboot/Makefile ===
# Install the netboot image build scripts as samples

include ../common.mak

NETBOOT_SAMPLEDIR=$(TOOLS_DATADIR)/netboot

all:

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(NETBOOT_SAMPLEDIR)
	$(INSTALL) -m 755 mk-s390image mk-pxelinux-ramfs \
		$(DESTDIR)$(NETBOOT_SAMPLEDIR)
	$(INSTALL) -m 644 Dockerfile Makefile.pxelinux.0 README.md \
		$(DESTDIR)$(NETBOOT_SAMPLEDIR)

.PHONY: all install clean

=== vmur/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -D_FILE_OFFSET_BITS=64
LDLIBS += -lz

all: vmur

libs =  $(rootdir)/libvmdump/libvmdump.a \
	$(rootdir)/libvmcp/libvmcp.a $(rootdir)/libutil/libutil.a

objects = vmur.o

vmur: $(objects) $(libs)
	$(LINKXX) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRSBINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 vmur $(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 vmur.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o vmur

.PHONY: all install clean

=== debian/changelog ===
s390-tools (2.12.0-0ubuntu3) focal; urgency=medium

  * Update patch series to master tip:
    - PVM / genprotimg LP: #1834534, FFe LP: #1866866
    - zipl/libc: Fix potential buffer overflow LP: #1865032
    - zipl: Fix secureboot documentation LP: #1864654
    - Many other smaller bugfixes

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 20 Mar 2020 12:08:13 +0000

s390-tools (2.12.0-0ubuntu2) focal; urgency=medium

  * Cherrypick more patches from upstream.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 25 Feb 2020 15:39:48 +0000

s390-tools (2.12.0-0ubuntu1) focal; urgency=medium

  * New upstream release, plus cherrypick patches from master.
    LP: #1860574 LP: #1860531 LP: #1859018 LP: #1853308

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 29 Jan 2020 22:27:05 +0000

s390-tools (2.11.0-0ubuntu2) focal; urgency=medium

  * Rebuild for libsnmp35.

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Tue, 14 Jan 2020 18:04:49 +0000

=== debian/control ===
Source: s390-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>, Philipp Kern <pkern@debian.org>
Build-Depends: debhelper (>> 9), libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev, libsnmp-dev, dh-systemd, libssl-dev, libcryptsetup-dev, libjson-c-dev, libglib2.0-dev
Standards-Version: 3.9.7
Homepage: http://www.ibm.com/developerworks/linux/linux390/s390-tools.html

Package: s390-tools
Architecture: s390 s390x
Priority: important
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, ${signing:Depends}, gawk
Recommends: sg3-utils
Suggests: s390-tools-cpuplugd, s390-tools-osasnmpd, s390-tools-statd, multipath-tools, lsscsi, rsync, blktrace
Description: fundamental utilities for Linux on z Systems
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.

Package: s390-tools-cpuplugd
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: cpuplugd utility for Linux on z Systems
 The package contains cpuplugd hotplug daemon from the s390-tools
 collection of utilities.

Package: s390-tools-statd
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: s390-tools (<<1.34.0-0ubuntu7~)
Replaces: s390-tools (<<1.34.0-0ubuntu7~)
Description: mon_statd monitoring daemons for Linux on z Systems
 The package contains mon_procd and mon_fsstatd z/VM monitoring
 daemons for Linux on z Systems from the s390-tools collection of
 utilities. These tools are also known as mon_statd.

Package: s390-tools-osasnmpd
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: osasnmpd utility for Linux on z Systems
 The package contains osasnmpd monitoring daemon from the s390-tools
 collection of utilities.

Package: s390-tools-zkey
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities.

Package: s390-tools-udeb
XC-Package-Type: udeb
Section: debian-installer
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: utilities for Linux on z Systems
 This is a minimal package used by debian-installer.
 This package contains only the binaries chzdev, lszdev, dasdfmt and
 fdasd.

Package: s390-tools-zkey-udeb
XC-Package-Type: udeb
Section: debian-installer
Priority: standard
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities for the debian-installer

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND=-D_GNU_SOURCE
export DEB_LDFLAGS_MAINT_APPEND=-rdynamic
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/lib/systemd/system

# Enable signing in Launchpad Only for now
SIGN_SIPL=
ifneq (,$(wildcard /CurrentlyBuilding))
SIGN_SIPL=yes
endif
SIGN_SIPL=yes

xnox:
	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))')

%:
	dh $@ --parallel --with systemd

override_dh_install:
	# no dracut
	rm -f debian/tmp/lib/s390-tools/zdev-root-update
	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump-initrd
	dh_install -ps390-tools-cpuplugd
	dh_install -ps390-tools-statd
	dh_install -ps390-tools-osasnmpd
	dh_install -ps390-tools-zkey -ps390-tools-zkey-udeb
	dh_install $(if $(SIGN_SIPL),-Xstage3.bin) -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd -X60-readahead.rules -Xzkey
	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))') >> debian/s390-tools.substvars

override_dh_auto_clean:
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)

signing=debian/s390-tools-$(DEB_VERSION)-signing/
signingv=$(signing)/$(DEB_VERSION)
signing_tar=$(DEB_SOURCE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).tar.gz
override_dh_builddeb:
	dh_builddeb
	mkdir -p $(signingv)/control
	echo 'tarball' >$(signingv)/control/options
	cp debian/tmp/lib/s390-tools/stage3.bin $(signingv)/stage3.bin.sipl
	tar -C $(signing) -czvf $(CURDIR)/../$(signing_tar) .
	dpkg-distaddfile $(signing_tar) raw-signing -
override_dh_clean:
	dh_clean
	rm -rf $(signing)

## s390-tools 2.14.0

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,9 @@
 	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
 	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
 	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
-	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl
+	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
+	   genprotimg
+
 SUB_DIRS = $(LIB_DIRS) $(TOOL_DIRS)
 
 all: $(TOOL_DIRS)

=== zkey/Makefile ===
include ../common.mak

ifneq (${HAVE_OPENSSL},0)
	BUILD_TARGETS += zkey
	INSTALL_TARGETS += install-zkey
else
	BUILD_TARGETS += zkey-skip
	INSTALL_TARGETS += zkey-skip
endif

ifneq (${HAVE_CRYPTSETUP2},0)
	ifneq (${HAVE_JSONC},0)
		BUILD_TARGETS += zkey-cryptsetup
		INSTALL_TARGETS += install-zkey-cryptsetup
		CPPFLAGS += -DHAVE_LUKS2_SUPPORT
	else
		BUILD_TARGETS += zkey-cryptsetup-skip-jsonc
		INSTALL_TARGETS += zkey-cryptsetup-skip-jsonc
	endif
else
	BUILD_TARGETS += zkey-cryptsetup-skip-cryptsetup2
	INSTALL_TARGETS += zkey-cryptsetup-skip-cryptsetup2
endif

libs = $(rootdir)/libutil/libutil.a

detect-libcryptsetup.dep:
	echo "#include <libcryptsetup.h>" > detect-libcryptsetup.dep
	echo "#ifndef CRYPT_LUKS2" >> detect-libcryptsetup.dep
	echo "  #error libcryptsetup version 2.0.3 is required" >> detect-libcryptsetup.dep
	echo "#endif" >> detect-libcryptsetup.dep
	echo "int i = CRYPT_SLOT_UNBOUND;" >> detect-libcryptsetup.dep

check-dep-zkey:
	$(call check_dep, \
		"zkey", \
		"openssl/evp.h", \
		"openssl-devel", \
		"HAVE_OPENSSL=0")
	touch check-dep-zkey

check-dep-zkey-cryptsetup: detect-libcryptsetup.dep
	$(call check_dep, \
		"zkey-cryptsetup", \
		"detect-libcryptsetup.dep", \
		"cryptsetup-devel version 2.0.3", \
		"HAVE_CRYPTSETUP2=0", \
		"-I.")
	$(call check_dep, \
		"zkey-cryptsetup", \
		"json-c/json.h", \
		"json-c-devel", \
		"HAVE_JSONC=0")
	touch check-dep-zkey-cryptsetup

zkey-skip:
	echo "  SKIP    zkey due to HAVE_OPENSSL=0"

zkey-cryptsetup-skip-cryptsetup2:
	echo "  SKIP    zkey-cryptsetup due to HAVE_CRYPTSETUP2=0"

zkey-cryptsetup-skip-jsonc:
	echo "  SKIP    zkey-cryptsetup due to HAVE_JSONC=0"

all: $(BUILD_TARGETS)

zkey.o: zkey.c pkey.h cca.h ep11.h misc.h
pkey.o: pkey.c pkey.h cca.h ep11.h utils.h
cca.o: cca.c cca.h pkey.h ep11.h utils.h
ep11.o: ep11.c ep11.h pkey.h cca.h utils.h
utils.o: utils.h pkey.h cca.h ep11.h
properties.o: check-dep-zkey properties.c properties.h
keystore.o: keystore.c keystore.h properties.h pkey.h cca.h ep11.h utils.h
zkey-cryptsetup.o: check-dep-zkey-cryptsetup zkey-cryptsetup.c pkey.h cca.h \
			ep11.h misc.h utils.h

zkey: LDLIBS = -ldl -lcrypto
zkey: zkey.o pkey.o cca.o ep11.o properties.o keystore.o utils.o $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

zkey-cryptsetup: LDLIBS = -ldl -lcryptsetup -ljson-c -lcrypto
zkey-cryptsetup: zkey-cryptsetup.o pkey.o cca.o ep11.o utils.o $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

install-common:
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1

install-zkey:
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -m 644 -c zkey.1 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -d -m 770 $(DESTDIR)$(SYSCONFDIR)/zkey
	$(INSTALL) -d -m 770 $(DESTDIR)$(SYSCONFDIR)/zkey/repository

install-zkey-cryptsetup:
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey-cryptsetup $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -m 644 -c zkey-cryptsetup.1 $(DESTDIR)$(MANDIR)/man1

install: all install-common $(INSTALL_TARGETS)

clean:
	rm -f *.o zkey zkey-cryptsetup detect-libcryptsetup.dep \
		check-dep-zkey check-dep-zkey-cryptsetup

.PHONY: all install clean zkey-skip zkey-cryptsetup-skip-cryptsetup2 \
	zkey-cryptsetup-skip-jsonc install-common install-zkey \
	install-zkey-cryptsetup

=== genprotimg/boot/Makefile ===
# Common definitions
include ../../common.mak

ZIPL_DIR := $(rootdir)/zipl
ZIPL_BOOT_DIR := $(ZIPL_DIR)/boot

INCLUDE_PATHS := $(ZIPL_BOOT_DIR) $(ZIPL_DIR)/include $(rootdir)/include
INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))

ALL_CFLAGS := $(NO_PIE_CFLAGS) -Os -g \
	$(INCLUDE_PARMS) \
	-DENABLE_SCLP_ASCII=1 \
	-DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	-fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	-fno-delete-null-pointer-checks \
	-fexec-charset=IBM1047 -m64 -mpacked-stack \
	-mstack-size=4096 -mstack-guard=128 -msoft-float \
	-Wall -Wformat-security -Wextra -Werror

FILES := stage3a.bin stage3b.bin stage3b_reloc.bin

ZIPL_SRCS_C := libc.c ebcdic.c ebcdic_conv.c sclp.c
ZIPL_SRCS_ASM := entry.S

ZIPL_OBJS_C := $(ZIPL_SRCS_C:%.c=%.o)
ZIPL_OBJS_ASM := $(ZIPL_SRCS_ASM:%.S=%.o)
ZIPL_OBJS := $(ZIPL_OBJS_C) $(ZIPL_OBJS_ASM)


all: $(FILES)

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S Makefile
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

%.o:	%.c Makefile
	$(CC) $(ALL_CFLAGS) -c -o $@ $<


# Dependencies for the .lds generation
sources_lds_S = $(wildcard *.lds.S)
dependencies_lds_S = $(sources_lds_S:%.lds.S=.%.lds.d)
# Include all ".lds.d" dependency files for all make targets except for "clean"
ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_lds_S)
endif

%.lds:	%.lds.S Makefile
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -P -C -o $@ $<

# Special rules for zipl object files
$(ZIPL_OBJS_C): %.o : $(ZIPL_BOOT_DIR)/%.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

$(ZIPL_OBJS_ASM): %.o : $(ZIPL_BOOT_DIR)/%.S
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

dependencies_zipl_c := $(ZIPL_SRCS_C:%.c=.%.o.d)

$(dependencies_zipl_c): .%.o.d : $(ZIPL_BOOT_DIR)/%.c
	$(CC_SILENT) -MM $(ALL_CPPFLAGS) $(ALL_CFLAGS) $< > $@

ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_zipl_c)
endif

stage3b_reloc.o: stage3b.bin

stage3a.elf: head.o stage3a_init.o stage3a.o stage3a.lds $(ZIPL_OBJS)
stage3b.elf: head.o stage3b.o stage3b.lds $(ZIPL_OBJS)
stage3b_reloc.elf:

%.elf:	%.o
	case $* in \
		stage3a) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-T,stage3a.lds";; \
		stage3b) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-T,stage3b.lds";; \
		stage3b_reloc) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-estage3b_reloc_start,-Ttext,0";; \
	esac; \
	$(LINK) $$SFLAGS -m64 $(filter %.o, $^) -o $@
	@chmod a-x $@

%.bin:	%.elf
	$(OBJCOPY) -O binary \
		--only-section=.text* \
		--only-section=.ex_table* \
		--only-section=.fixup* \
		--only-section=.data*  \
		--only-section=.rodata* \
		$< $@
	@chmod a-x $@

clean:
	rm -f *.o *.elf *.bin *.map .*.d *.lds

.PHONY: all clean

=== zipl/boot/Makefile ===
# Common definitions
include ../../common.mak

INCLUDE_PATHS := $(rootdir)/zipl/include $(rootdir)/include
INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))

ALL_CFLAGS = $(NO_PIE_CFLAGS) -Os -g $(INCLUDE_PARMS) \
	  -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	  -fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	  -fno-delete-null-pointer-checks \
	  -fexec-charset=IBM1047 -m64 -mpacked-stack \
	  -mstack-size=4096 -mstack-guard=128 -msoft-float \
	  -W -Wall -Wformat-security

FILES	= fba0.bin fba1b.bin fba2.bin \
	  eckd0_ldl.bin eckd0_cdl.bin \
	  eckd1.bin eckd1b.bin eckd2.bin \
	  tape0.bin \
	  eckd2dump_sv.bin tape2dump.bin fba2dump.bin eckd2dump_mv.bin

all: data.o data.h tape0.bin stage3.bin

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

%.o:	%.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

# Dependencies for the .lds generation
sources_lds_S = $(wildcard *.lds.S)
dependencies_lds_S = $(sources_lds_S:%.lds.S=.%.lds.d)
# Include all ".lds.d" dependency files for all make targets except for "clean"
ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_lds_S)
endif

%.lds: %.lds.S
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -P -C -o $@ $<

eckd2dump_sv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_sv.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
eckd2dump_mv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_mv.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
fba2dump.exec: \
	head.o stage2dump.o cio.o fba2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
tape2dump.exec: \
	head.o stage2dump.o cio.o tape2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
eckd2.exec: head.o stage2.o cio.o eckd2.o libc.o ebcdic.o menu.o sclp.o \
	    kdump2.o kdump.o entry.o stage2.lds
fba2.exec: head.o stage2.o cio.o fba2.o libc.o ebcdic.o menu.o sclp.o \
	   kdump2.o kdump.o entry.o stage2.lds
stage3.exec: head.o stage3.o kdump3.o libc.o ebcdic.o ebcdic_conv.o sclp.o \
	     sclp_stage3.o kdump.o entry.o stage3.lds

%.exec:	%.o
	STAGE=$$( \
		echo $@ | awk ' \
			match($$0,/[0-9]+b*/){ \
				print substr($$0,RSTART,RLENGTH) \
			}' \
	); \
	case $$STAGE in \
		0) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-Ttext,0";; \
		1) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-Ttext,0x18";; \
		1b) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-Ttext,0xE000";; \
		2) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-T,stage2.lds";; \
		3) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-T,stage3.lds";; \
	esac; \
	$(LINK) $$SFLAGS -m64 $(filter %.o, $^) -o $@

%.bin:	%.exec
	$(OBJCOPY) -O binary \
		--only-section=.stage2.head \
		--only-section=.text.dummy \
		--only-section=.text.start \
		--only-section=.text \
		--only-section=.ex_table \
		--only-section=.data \
		--only-section=.rodata.str1.2 \
		--only-section=.rodata.cst8 \
		--only-section=.rodata \
		--only-section=.stage2dump.tail \
		--only-section=.eckd2dump_mv.tail \
		--only-section=.fixup \
		$< $@

stage3.bin:	stage3.exec
	$(OBJCOPY) -O binary \
		--only-section=.stage2.head \
		--only-section=.text.dummy \
		--only-section=.text.start \
		--only-section=.text \
		--only-section=.ex_table \
		--only-section=.data \
		--only-section=.rodata.str1.2 \
		--only-section=.rodata.cst8 \
		--only-section=.rodata \
		--only-section=.stage2dump.tail \
		--only-section=.eckd2dump_mv.tail \
		--only-section=.fixup \
		--pad-to=0xe000 \
		$< $@

data.o: $(FILES)
	$(LD) $(NO_PIE_LDFLAGS) -r -b binary -o data.o $(FILES)

data.h: data.o
	rm -f data.h
	$(NM) data.o | while read ADDR TYPE SYMBOL ; do \
				echo "extern char $$SYMBOL;" >>data.h; done

clean:
	rm -f *.o *.exec *.bin $(FILES) data.o data.h tape0.bin *.xxx *.yyy \
	      stage3.bin *.lds *.lds.d

.PHONY: all clean

=== debian/changelog ===
s390-tools (2.14.0-1ubuntu1) groovy; urgency=medium

  * Merge from Debian, remaining changes:
    - add libssl-dev, libglib2.0-dev build-deps
    - add support for signed zipl
    - package cpuplugd, osasnmpd, statd, zkey
    - update copyright file
    - fix kernel installer script integration, to skip calling zipl without initrd
    - load monwriter kernel module for mon_statd/mon_fsstatd
    - do not run dumpconf in lxc
    - ziomon change exit code to 0 for version and help
    - add zkey initramfs hook
    - change zkey default back to argon2i
    - drop patch that disables building osasnmpd
    - drop udevpath patch to init script, systemd units are used instead
    - enable hardening
    - enable initramfs & dracut integration
    - install more utilities and zdev initramfs integration
    - setup users/groups for mon_*, iucvterm, zkey
    - setup crashkernel integration
    - ship zdev in udeb
    - drop ziomon package, shipped in the main package

  * New upstream release fixes LP: #1892350, LP: #1888231, LP: #1884773,
    LP: #1884744, LP: #1884721

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 26 Aug 2020 11:11:23 +0100

s390-tools (2.14.0-1) unstable; urgency=medium

  * New upstream release.

 -- Philipp Kern <pkern@debian.org>  Sun, 23 Aug 2020 08:04:49 -0400

s390-tools (2.12.0-0ubuntu6) groovy; urgency=medium

  * Rebuild against new json-c5.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jul 2020 19:56:05 +0200

s390-tools (2.12.0-0ubuntu5) groovy; urgency=medium

  * lsluns: fix udevadm calls to settle LP: #1873973.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 10 Jul 2020 12:44:00 +0100

s390-tools (2.12.0-0ubuntu4) groovy; urgency=medium

  * Don't run dumpconf service in LXC
    It just fails to start in unprivileged containers

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 20 May 2020 14:34:58 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
 Uploaders: Bastian Blank <waldi@debian.org>, Philipp Kern <pkern@debian.org>
-Build-Depends: debhelper (>> 9), libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev, libsnmp-dev, dh-systemd, libssl-dev, libcryptsetup-dev, libjson-c-dev, libglib2.0-dev
+Build-Depends: debhelper (>> 9), libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev, libcurl4-openssl-dev, libsnmp-dev, dh-systemd, libssl-dev, libcryptsetup-dev, libjson-c-dev, libglib2.0-dev
 Standards-Version: 3.9.7
 Homepage: http://www.ibm.com/developerworks/linux/linux390/s390-tools.html
 
 Package: s390-tools
 Architecture: s390 s390x
 Priority: important
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, ${signing:Depends}, gawk
+Depends: ${shlibs:Depends}, ${misc:Depends}, perl, ${signing:Depends}, gawk
 Recommends: sg3-utils
 Suggests: s390-tools-cpuplugd, s390-tools-osasnmpd, s390-tools-statd, multipath-tools, lsscsi, rsync, blktrace
 Description: fundamental utilities for Linux on z Systems

=== debian/rules ===
--- 
+++ 
@@ -14,9 +14,6 @@
 SIGN_SIPL=yes
 endif
 SIGN_SIPL=yes
-
-xnox:
-	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))')
 
 %:
 	dh $@ --parallel --with systemd
